> ## Documentation Index
> Fetch the complete documentation index at: https://developer.watson-orchestrate.ibm.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Policies



## OpenAPI

````yaml post /v1/outbound-policies
openapi: 3.1.0
info:
  title: WxO Server API
  summary: API for the next gen watsonx Orchestrate stack
  description: >+

    The watsonx Orchestrate Server provides a set of APIs to power the watsonx
    Orchestrate AI assistant. This includes the following core services:


    * Orchestrate Assistant - a built-in AI assistant that powers the
    Orchestrate end-user experience.

    * Custom Assistants - a service layer for interacting with existing AI
    assistatns (such as those in watsonx Assistant).

    * Message Threads - a chat history and async message tracking store.

    * Document Store - manage collections of documents in nearly any format
    including text, pdf, html and many more.

    * Information Extraction - automatically extract clean text and images from
    any document in the Document Store.  Also extract other useful metadata like
    questions answered, keywords, and named entities.

    * Embedding - generate vector embeddings for text and images in the Document
    Store.

    * Vector Index and Retrieval - automatically index documents with rich
    metadata for vector search or hybrid search.

    * Search Engine - create a Gen AI powered search engine that works like Bing
    or Google.

    * Query Engine - configure your own RAG (Retrieval Augmented Generation)
    engine supporting advanced retrieval patterns and automated data management.

    * Model Proxy - create your own LLM model endpoints for chat completions and
    embeddings.  Supports IBM watsonx.ai, IBM BAM, OpenAI, MistralAI, or Ollama
    for local models.


    WxO API Server utilizes the following open source projects:


    * [PostgreSQL](https://www.postgresql.org/)

    * [PGVector](https://github.com/pgvector/pgvector)

    * [LlamaIndex](https://docs.llamaindex.ai/en/stable/)

    * [LangChain](https://python.langchain.com/docs/get_started/introduction)

    * [FastAPI](https://fastapi.tiangolo.com/)

    * [Unstructured](https://unstructured.io/)

    * [Celery](https://docs.celeryproject.org/en/stable/)

  version: 0.1.0
servers:
  - url: https://{api_endpoint}
    description: version
security: []
paths:
  /v1/outbound-policies:
    post:
      tags:
        - Outbound Policies
      summary: Create Policies
      operationId: Create_policies_v1_outbound_policies_post
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PolicyCreate'
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreatePolicyResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - HTTPBearer: []
components:
  schemas:
    PolicyCreate:
      properties:
        tenant_rules:
          $ref: '#/components/schemas/ServicePolicy'
      type: object
      required:
        - tenant_rules
      title: PolicyCreate
    CreatePolicyResponse:
      properties:
        success:
          type: boolean
          title: Success
        added:
          type: integer
          title: Added
        failed:
          type: integer
          title: Failed
        results:
          additionalProperties:
            $ref: '#/components/schemas/ServicePolicyResponse'
          type: object
          title: Results
      type: object
      required:
        - success
        - added
        - failed
        - results
      title: CreatePolicyResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ServicePolicy:
      properties:
        policy:
          $ref: '#/components/schemas/OutboundPolicyEnum'
        rules:
          items:
            $ref: '#/components/schemas/CreateRule'
          type: array
          title: Rules
      type: object
      required:
        - policy
        - rules
      title: ServicePolicy
    ServicePolicyResponse:
      properties:
        policy:
          $ref: '#/components/schemas/OutboundPolicyEnum'
        rules:
          items:
            $ref: '#/components/schemas/RulesResponse'
          type: array
          title: Rules
      type: object
      required:
        - policy
        - rules
      title: ServicePolicyResponse
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    OutboundPolicyEnum:
      type: string
      enum:
        - allow
        - deny
      title: OutboundPolicyEnum
    CreateRule:
      properties:
        policy:
          $ref: '#/components/schemas/OutboundPolicyEnum'
        entity_value:
          type: string
          title: Entity Value
      type: object
      required:
        - policy
        - entity_value
      title: CreateRule
    RulesResponse:
      properties:
        policy:
          $ref: '#/components/schemas/OutboundPolicyEnum'
        entity_value:
          type: string
          title: Entity Value
        id:
          type: string
          format: uuid
          title: Id
      type: object
      required:
        - policy
        - entity_value
        - id
      title: RulesResponse
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````